c converts binary file to ascii file
c.. Remar: adapted from follow.f

	include '../../swift.inc'

	real*8 xjt(NTPMAX),yjt(NTPMAX),zjt(NTPMAX)
	real*8 vxjt(NTPMAX),vyjt(NTPMAX),vzjt(NTPMAX)

	real*8 mass(NPLMAX),dr,peri
	real*8 xj(NPLMAX),yj(NPLMAX),zj(NPLMAX)
	real*8 vxj(NPLMAX),vyj(NPLMAX),vzj(NPLMAX)

	integer istat(NTPMAX,NSTAT)
        real*8 rstat(NTPMAX,NSTATR)
        real*8 umat(NPLMAX,NPLMAX),mat(NPLMAX,NPLMAX)
        real*8 umatp(NPLMAX,NTPMAX),matp(NPLMAX,NTPMAX)
        real*8 mu(NPLMAX),eta(NPLMAX),etatp(NTPMAX)
        integer oloc(NPLMAX,NPLMAX),oloct(NPLMAX,NTPMAX)
	integer nbod,ntp,ierr,ifol,istep
	integer iflgchk,iu,nleft,i,id
        integer io_read_hdr,io_read_line
        integer io_read_hdr_r,io_read_line_r

	real*8 t0,tstop,dt,dtout,dtdump
	real*8 t,tmax

	real*8 rmin,rmax,rmaxu,qmin,rplsq(NPLMAX)
        logical*2 lclose
        real*8 a,e,inc,capom,omega,capm,j2rp2,j4rp4
        real*8 elh,elk,elp,elq,apo

	character*80 outfile,inparfile,inplfile,intpfile,fopenstat

c Get data for the run and the test particles
	write(*,*) 'Enter name of parameter data file : '
	read(*,999) inparfile
	call io_init_param(inparfile,t0,tstop,dt,dtout,dtdump,
     &         iflgchk,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat)

c Prompt and read name of massive bodies data file
	write(*,*) ' '
	write(*,*) 'Enter name of massive bodies data file : '
	read(*,999) inplfile
999 	format(a)
	call io_init_pl_hjs(inplfile,lclose,iflgchk,nbod,oloc,
     &       mass,eta,mu,mat,umat,xj,yj,zj,vxj,vyj,vzj,rplsq)

c Get data for the run and the test particles
	write(*,*) 'Enter name of test particle data file : '
	read(*,999) intpfile
        call io_init_tp_hjs(intpfile,nbod,ntp,oloc,oloct,mass,umat,
     &         etatp,matp,umatp,xjt,yjt,zjt,vxjt,vyjt,vzjt,istat,rstat)

        iu = 20

        dr = 180.0/PI

        if(btest(iflgchk,0)) then
           write(*,*) ' Reading an integer*2 binary file '
        else if(btest(iflgchk,1)) then
           write(*,*) ' Reading an real*4 binary file '
        else
           write(*,*) ' ERROR: no binary file format specified '
           write(*,*) '        in param file '
           stop
        endif

        write(*,*) ' Input the particle number or orbit to follow '
        read(*,*) ifol
        write(*,*) ' Following particle ',ifol

        open(unit=iu, file=outfile, status='old',form='unformatted')
        open(unit=7,file='follow.out')
        open(unit=8,file='follow_hkpq.out')

        write(*,*) '1 2 3  4    5     6    7    8    9 '
        write(*,*) 't,a,e,inc,capom,omega,capm,peri,apo'

        tmax = t0
 1      continue
             if(btest(iflgchk,0))  then ! bit 0 is set
                ierr = io_read_hdr(iu,t,nbod,nleft) 
             else
                ierr = io_read_hdr_r(iu,t,nbod,nleft) 
             endif
             print*,nleft

             if(ierr.ne.0) goto 2

             istep = 0
             do i=2,nbod
                if(btest(iflgchk,0))  then ! bit 0 is set
                   ierr = io_read_line(iu,id,a,e,inc,capom,omega,capm) 
                else
                   ierr = io_read_line_r(iu,id,a,e,inc,capom,omega,capm) 
                endif
                if(ierr.ne.0) goto 2
                if(id.eq.ifol) then
                   istep = 1
                   elh = e*cos(omega+capom)
                   elk = e*sin(omega+capom)
                   elp = sin(inc/2.0)*cos(capom)
                   elq = sin(inc/2.0)*sin(capom)
                   inc = inc*dr
                   capom = capom*dr
                   omega = omega*dr
                   capm = capm*dr
                   peri = a*(1.0d0-e)
                   apo = a*(1.0d0+e)
                   write(7,1000) t,a,e,inc,capom,omega,capm,peri,apo
 1000              format(1x,e15.7,1x,f10.4,1x,f7.5,4(1x,f9.4),
     &                  2(1x,f10.4))
                   write(8,1001) t,elh,elk,elp,elq
 1001              format(1x,e13.5,4(1x,f7.5))
                   tmax = t
                endif
             enddo

             do i=1,nleft
                if(btest(iflgchk,0))  then ! bit 0 is set
                   ierr = io_read_line(iu,id,a,e,inc,capom,omega,capm) 
                else
                   ierr = io_read_line_r(iu,id,a,e,inc,capom,omega,capm) 
                endif
                if(ierr.ne.0) goto 2
                if(id.eq.ifol) then
                   istep = 1
                   elh = e*cos(omega+capom)
                   elk = e*sin(omega+capom)
                   elp = sin(inc/2.0)*cos(capom)
                   elq = sin(inc/2.0)*sin(capom)
                   inc = inc*dr
                   capom = capom*dr
                   omega = omega*dr
                   capm = capm*dr
                   peri = a*(1.0d0-e)
                   apo = a*(1.0d0+e)
                   write(7,1000) t,a,e,inc,capom,omega,capm,peri,apo
                   tmax = t
                   write(8,1001) t,elh,elk,elp,elq
                endif
             enddo
             if(istep.eq.0) goto 2     ! did not find particle this times step

        goto 1

 2      continue

        write(*,*) ' Tmax = ',tmax

        stop
        end
